
var b bnot c ctilde ec lb maxlev y ;
varexo eps_u ;

parameters RHO, BETA, M, R, STD_U, GAMMAC  ;

R = 1.05;
BETA = 0.945;
RHO   = 0.9;
STD_U = 0.02;
M = 1;
GAMMAC = 1;



model;
ec = c(1);
c = y + b - R*b(-1) ;
b =  M*y ;
bnot =  M*y ;
lb = 1/c^GAMMAC - BETA*R/c(+1)^GAMMAC ;
log(y) = RHO*log(y(-1)) + eps_u ;
maxlev = b-bnot;
ctilde = c-(1+M-R*M);
end;


//%stoch_simul(order=1,noprint,nomoments,irf=0);



shocks;
var eps_u; stderr STD_U;
end;


varobs ctilde ;

estimated_params ;


//%            START VALUES          &           PRIORS
GAMMAC         ,       3.000000  ,  0    ,  Inf  ,        normal_pdf   ,   3     ,  1 ;
RHO            ,       0.669165  ,  0    ,   1   ,        beta_pdf   ,     0.5   ,   0.10 ;      
stderr eps_u   ,       0.009880  ,  0    ,  Inf  ,        inv_gamma_pdf,   0.01  ,  1 ;     
end;

options_.subdraws = 100;

estimation(datafile=fakedata_dynare,
mh_jscale=0.35, 
mode_compute=8, mode_check,plot_priors=0,
smoother,  
presample=0, prior_trunc=1e-12,
mh_replic=0,  mh_nblocks=1, lik_init=1, order=1) ctilde;

save estimation_dynare ;










