//% Three equations DNK model 
var aap, aar, aay, p, pnot, r, rlong, rnot, y, ynot;
varexo eps_p eps_r eps_y;

parameters BETA FIP FIY FIR LAMBDA PHI RHOY RHOR;


model(linear);
//% IS curve (Equation 2.1 in CGG JEL 1999 paper)
y = y(+1) - PHI*(r - p(+1)) + aay ;

//% Phillips curve (Equation 2.2 in CGG JEL 1999 paper)
p = BETA*p(+1) + LAMBDA*y + eps_p ;

//% Aggregate Demand disturbance (Equation 2.3)
aay = RHOY*aay(-1) + eps_y;
aar = RHOR*aar(-1) + eps_r;
aap = eps_p;

rlong = 0.10*r + 0.90*rlong(+1);
r = -(1/BETA-1);

//% Interest Rate rule with ZLB
rnot = FIR*r(-1) + (1-FIR)*(FIP*pnot + FIY*ynot) + aar ;
ynot = ynot(+1) - PHI*(rnot - pnot(+1)) + aay ;
pnot = BETA*pnot(+1) + LAMBDA*ynot + eps_p ;

end;

						  
