//% Three equations DNK model 
var aap, aar, aay, p, r, rlong, rnot, y;
varexo eps_p eps_r eps_y;

parameters BETA FIP FIY FIR LAMBDA PHI RHOY;


model(linear);
//% IS curve (Equation 2.1 in CGG JEL 1999 paper)
y = y(+1) - PHI*(r - p(+1)) + aay ;

//% Phillips curve (Equation 2.2 in CGG JEL 1999 paper)
p = BETA*p(+1) + LAMBDA*y + eps_p ;

//% Aggregate Demand disturbance (Equation 2.3)
aay = RHOY*aay(-1) + eps_y;
aap = eps_p;
aar = 0*eps_r;

rlong = 0.10*r + 0.90*rlong(+1);

//% Interest Rate rule with ZLB
rnot = FIR*rnot(-1) + (1-FIR)*(FIP*p + FIY*y)  ;
r = -(1/BETA-1);

end;

						  
